"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var slate_1 = require("slate");
var tinycolor2_1 = tslib_1.__importDefault(require("tinycolor2"));
function createCommands(opt) {
    var _a;
    var defaultColor = opt.defaultColor, data = opt.data, type = opt.type, name = opt.name;
    return _a = {},
        _a["change" + name + "Color"] = function (editor, color) {
            var _a, _b;
            var value = editor.value;
            var selection = value.selection;
            if (editor.hasMark(value, type)) {
                if (tinycolor2_1.default(color).toName() === defaultColor) {
                    if (selection.isCollapsed) {
                        editor.removeCollapsedMark(type);
                    }
                    else {
                        editor.removeExpandedMark(type);
                    }
                }
                else {
                    var newMark = new slate_1.Mark({
                        type: type,
                        data: slate_1.Data.create((_a = {},
                            _a[data] = color,
                            _a))
                    });
                    if (selection.isCollapsed) {
                        editor
                            .removeCollapsedMark(type)
                            .focus()
                            .addMark(newMark);
                    }
                    else {
                        editor.removeExpandedMark(type).addMarkAtRange(selection, newMark);
                    }
                }
            }
            else if (tinycolor2_1.default(color).toName() !== defaultColor) {
                var mark = new slate_1.Mark({
                    type: type,
                    data: slate_1.Data.create((_b = {},
                        _b[data] = color,
                        _b))
                });
                if (selection.isCollapsed) {
                    editor.addMark(mark);
                }
                else {
                    editor.removeExpandedMark(type).addMarkAtRange(selection, mark);
                }
            }
            editor.focus();
            return;
        },
        _a;
}
exports.default = createCommands;
//# sourceMappingURL=index.js.map