"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var tinycolor2_1 = tslib_1.__importDefault(require("tinycolor2"));
var defaultStyle = {
    textDecoration: "inherit",
    textDecorationColor: "inherit"
};
function createProps(opts) {
    var type = opts.type, dataField = opts.data, styleFields = opts.styles, alpha = opts.alpha;
    return function (props) {
        if (!props.mark || props.mark.type !== type)
            return props;
        var attributes = props.attributes, data = props.mark.data;
        var style = (attributes || { style: {} }).style;
        var color = tinycolor2_1.default(data.get(dataField));
        style = tslib_1.__assign({}, defaultStyle, style, { textDecoration: "inherit", decorationStyle: "initial" }, styleFields.reduce(function (acc, styleField) {
            var _a;
            return (tslib_1.__assign({}, acc, (_a = {}, _a[styleField] = color.setAlpha(alpha).toRgbString(), _a)));
        }, {}));
        return tslib_1.__assign({}, props, { attributes: tslib_1.__assign({}, props.attributes, { style: style }) });
    };
}
exports.default = createProps;
//# sourceMappingURL=index.js.map